<template>
  <div class="bargainList pagePadding">
    <div v-if=" powers.some((i) => i == '001')">
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row>
              <el-col :span="4" style="width: 301px; padding: 0 10px 0 0">
                <period-date-picker
                  :start="parmValue.createStart"
                  :end="parmValue.createEnd"
                  :width="'134px'"
                  :size="searchSize"
                  @timeReturned="handleTime"
                />
              </el-col>

              <el-col :span="4" style="width: 205px;padding-right:10px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  clearable
                  placeholder="状态"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();"
                >
                  <el-option
                    v-for="item in statusList"
                    :label="item.label"
                    :value="item.id"
                    :key="item.id"
                  />
                </el-select>
              </el-col>

              <!-- <el-col :span="4" style="width: 145px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.backStatus"
                  clearable
                  placeholder="回款状态"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();">
                  <el-option
                    v-for="item in statusList"
                    :key="item.id"
                    :label="item.label"
                    :value="item.id"/>
                </el-select>
              </el-col>-->

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >刷新</el-button>
              </el-col>
              <el-col :span="4" class="fr" style="width: 66px">
                <el-button type="warning" class="fr" :size="searchSize" @click="restSearch">重置</el-button>
              </el-col>
            </el-row>

            <el-row style="margin-top: 10px;">
              <el-col :span="4">
                <el-input
                  size="mini"
                  v-model="parmValue.settle_code"
                  placeholder="平台结算编号"
                  clearable
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                />
              </el-col>

              <el-col :span="4" style="margin-left:10px">
                <el-input
                  size="mini"
                  v-model="parmValue.reqCode"
                  placeholder="需求订单编号"
                  clearable
                  @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();"
                />
              </el-col>
            </el-row>

            <el-row></el-row>
          </div>
        </template>

        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="
              (statusList.find((item) => item.id == scope.row.status) || {})
                .type || ''
            "
            v-text="
              (statusList.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>

        <template #title="{scope}">
          <div style="display: flex;height: 23px">
            <el-popover placement="top" trigger="hover">
              <show-data-table
                border
                :sitem="scope.row"
                style="padding: -5px 0px 10px 0px"
                :columns="invoiceColumns"
              >
                <template #tel>
                  {{scope.row.invoice_addr}}
                  {{scope.row.invoice_mobile}}
                </template>

                <template #bank>
                  {{scope.row.invoice_bank}}
                  {{scope.row.invoice_bankNo}}
                </template>
              </show-data-table>

              <template #reference>
                <i class="el-icon-warning-outline" v-if="scope.row.invoice_code" />
                <span style="margin-right:5px">{{scope.row.invoice_title}}</span>
              </template>
            </el-popover>
          </div>
        </template>

        <template #supplier="{ scope }">
          <div style="display:flex;align-items:center">
            <el-tooltip :content="'供应商编号 : ' + scope.row.supplierNo" placement="top">
              <i v-if="scope.row.supplierNo" class="el-icon-warning-outline" />
            </el-tooltip>
            <span style="margin-right:5px">{{scope.row.supplierName}}</span>
          </div>
        </template>

        <template #good_name="{ scope }">
          <span>{{ scope.row.good_name }}</span>
          <span
            v-for="(si, sii) in scope.row.specinfo"
            :key="si.spec_value_id + sii"
          >{{ sii == 0 ? "__" : "--" }}{{ si.spec_name }}[{{si.spec_value_name}}]</span>
        </template>
        <template #can="{ scope }">
          <span v-for="(si, sii) in scope.row.can" :key="si.id + sii">
            <span v-if="sii !== 0">_</span>
            {{ si.name }}
          </span>
        </template>
        <template #operation="{ scope }">
          <el-tooltip effect="dark" content="详情" placement="top">
            <i class="el-icon-view tb-icon" @click="getRouter('settlementDetail', scope.row.id )" />
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/platformService/settlement";
import companyHelper from "@/mixins/companyHelper";
import { listCol, statusList } from "./columns";
import { mapGetters } from "vuex";

/**
 * @props
 * 创建时间开始 createStart
 * 创建时间结束属性 createEnd
 * 开票状态 status
 * 回票状态 backStatus
 * 需求订单编号 reqCode
 * 平台结算编号 settle_code
 */

export default {
  name: "settlement",
  mixins: [mixinPage, resToken, companyHelper],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          item => item.menu_route == "settlement"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    }
  },
  data() {
    return {
      statusList,
      sitem: null,
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        createStart: "",
        createEnd: "",
        status: "",
        backStatus: "",
        reqCode: "",
        settle_code: "",
        page: 1, // 页码
        size: 15 // 每页显示条数
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: []
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0
      },
      // 表格 - 列参数
      columns: listCol,
      invoiceColumns: [
        {
          prop: "invoice_title",
          label: "抬头",
          span: 24
        },
        {
          prop: "invoice_code",
          label: "纳税人识别号",
          span: 24
        },
        {
          prop: "tel",
          label: "地址、电话",
          span: 24,
          _slot_: "tel"
        },
        {
          prop: "bank_account",
          label: "开户行及账号",
          span: 24,
          _slot_: "bank"
        }
      ],

      resultValue: "" //处理结果
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      const { page, size } = this.parmValue;
      this.pageInfo = {
        size: size,
        curr: page,
        total: 0
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.s_input = this.parmValue.s_input;
    } else {
      this.select = "1";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    getRouter(toRouter, queryId) {
      console.log(toRouter, queryId);
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          type: "view"
        };

        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      this.customerCode = [];
      this.select = "1";
      this.s_input = "";
      this.parmValue = {
        createStart: "",
        createEnd: "",
        status: "",
        backStatus: "",
        reqCode: "",
        settle_code: "",
        page: 1, // 页码
        size: 15 // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(async () => {
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1"
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: ""
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 列表搜索
    async searchList() {
      if (
        (this.parmValue.createStart !== "" &&
          this.parmValue.createEnd === "") ||
        (this.parmValue.createStart === "" && this.parmValue.createEnd !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }

      this.loading = true;

      const res = await asyncRequest.list({
        ...this.parmValue
      });

      if (res && res.code === 1 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status + "" === "1" ? "禁用" : "启用";

      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1"
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: ""
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 时间选择事件
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue.createStart = e.startTime;
      } else {
        this.parmValue.createStart = "";
      }
      if (e.endTime !== "") {
        this.parmValue.createEnd = e.endTime;
      } else {
        this.parmValue.createEnd = "";
      }
      if (
        this.parmValue.createStart !== "" &&
        this.parmValue.createEnd !== ""
      ) {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    async customerChange(e) {
      const { code } = e;
      this.parmValue.customer_code = code ? [code] : [];
      this.parmValue.supplierName = e.label;
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    }
  }
};
</script>
   <style lang="scss" scoped>
.bargainList {
}
</style>
   